#!/bin/bash
#
# SNGetter stands for Simple Network Getter
#
# This script works together with snplayer, the Simple Network Player
# it takes care of downloading a playlist and its corresponding video
# files. It loops forever checking for a new playlist.
#
# Copyright by Carlos Rivera, 2007.
#
# This script is free software, see file COPYING for licence information.

source __SYSCONFDIR__/snplayer &> /dev/null
source $HOME/.snplayer &> /dev/null

while `true`
do
    wget -O $CACHE_DIR/playlist.new -N -t 1 -r $PLAYLIST_URL

    size=`stat -c %s /var/spool/snplayer/playlist.new`
    
    echo "new playlist size is $size"

    if [ $size != "0" ]
    then
        mv $CACHE_DIR/playlist.new $CACHE_DIR/playlist	
        wget -i $CACHE_DIR/playlist -N -r -t 1 \
                                             --directory-prefix=$CACHE_DIR/media
    fi

    playlist=`cat $CACHE_DIR/playlist | cut -d/ -f 3- | awk "{ print \"$CACHE_DIR/media/\" \\$0 }" | xargs`

    # delete whatever is in cache and no longer needed.
    for i in `find $CACHE_DIR/media/ -type f`
    do
        echo testing $i ...

        if [ "x`echo $playlist | grep $i`" == "x" ]
        then
            echo "CACHE MISS: $i   -- deleting! --" 
            rm $i -f
        fi
    done

    # prune empty cache directories
    for i in `find $CACHE_DIR/media/ -mindepth 1 -type d`
    do
        if [ "x`ls $i`" == "x" ]
        then
            rmdir $i
        fi
    done

    echo sleeping for $DOWNLOAD_PERIOD seconds . . .
    sleep $DOWNLOAD_PERIOD
done
